<?php


### Created 2002-03-30, by Thomas Kaeser - tkaeser@mail.com ### 


//----------------- calculates EAN8 check digit -------

function CheckDigit($list)	{
	
	$oddsum=$list[0]+$list[2]+$list[4]+$list[6];
	$evensum=$list[1]+$list[3]+$list[5];
	$check=(10 - ((3*$oddsum+$evensum)%10))%10; 
	
	return $check;
}


//-----------------takes a data string of 7 digits and returns the corresponding EAN-8 symbol using EAN13.ttf-------

function EAN8($data) {
	
	$data=trim($data); // chop spaces, convert string to array
	$list=array();
	for ($i=0; $i<7; $i++)	{
		$list[]=substr($data, $i, 1);
	}
	
	$list[]=CheckDigit($list); // append check digit
	
	// offsets for ASCII codes
	$LeftHandA=48;
	$RightHand=80;
	$SecondFlag=96;
	$CheckChar=112;
	$CenterGuard=124;

	$list[0]= chr($SecondFlag+$list[0]); //encode first flag
	
	for ($i=1; $i<4; $i++)	{ // encode left hand data
				$list[$i]= chr($LeftHandA+$list[$i]);
	}
	
	for ($i=4; $i<7; $i++)	{ // encode right hand data
		$list[$i]= chr($RightHand+$list[$i]);
	}
	
	$list[7]= chr($CheckChar+$list[7]); // encode check digit
	
	$barcode=implode($list, ''); // convert array to string
	
	$barcode=substr($barcode,0,4).chr($CenterGuard).substr($barcode,4,4); // add center guard
	
	return $barcode; // et voila!
	
}

?>


<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">

<html>
<head>
	<title>EAN-8 Symbol</title>
</head>

<body>

<form name="ean8" action="ean8.php3" method="post">
	<table border='1' cellspacing='5' cellpadding='5' align='center'>
		<tr>
			<td colspan=2 align='center'><input type='text' name='data' size='7' maxlength='7'></td>  
		</tr>
		<tr>
			<td><input type='reset' value='reset'></td>
			<td><input type='submit' name='create' value='create'></td>
		</tr>
		<tr>
		<tr>
			<td colspan='2' style='font-family: EAN-13; font-size: 48px; height=80px; text-align=center;'>
				<?php
				if (isset($data))	{
					$barcode=EAN8($data);
					echo $barcode;
				}
				?>
			</td>
		</tr>	
	</table>
</form>

</body>
</html>
